Index: commands.cxx
===================================================================
--- commands.cxx	(revision 20911)
+++ commands.cxx	(working copy)
@@ -1260,11 +1260,16 @@
 static void flagCommandHelp(int t)
 {
   sendMessage(ServerPlayer, t, "/flag up");
+  sendMessage(ServerPlayer, t, "/flag list");
   sendMessage(ServerPlayer, t, "/flag show");
   sendMessage(ServerPlayer, t, "/flag reset <all|unused|team|#flagId|FlagAbbv>");
   sendMessage(ServerPlayer, t, "/flag take <#slot|PlayerName|\"PlayerName\">");
   sendMessage(ServerPlayer, t,
 	      "/flag give <#slot|PlayerName|\"PlayerName\"> <#flagId|FlagAbbr> [force]");
+  sendMessage(ServerPlayer, t, "/flag ff <all|bad|good|team|FlagAbbv> [count]");
+  sendMessage(ServerPlayer, t, "/flag fr <all|bad|good|FlagAbbv> [count]");
+  sendMessage(ServerPlayer, t, "/flag frmax <count>");
+  sendMessage(ServerPlayer, t, "/flag frtimes <min> <max>");
   return;
 }
 
@@ -1304,22 +1309,25 @@
   while ((*msg != '\0') && isspace(*msg)) msg++; // eat whitespace
 
   if (strncasecmp(msg, "up", 2) == 0) {
-    for (int i = 0; i < numFlags; i++) {
-      FlagInfo &flag = *FlagInfo::get(i);
-      if (flag.flag.type->flagTeam == ::NoTeam) {
+    for (int i = 0; i < FLAGMGR.size(); i++) {
+      FlagInfo &flag = *FLAGMGR.getFlag(i);
+      if (flag.getTeamIndex() == ::NoTeam) {
 	sendDrop(flag);
-	flag.flag.status = FlagGoing;
-	if (!flag.required) {
-	  flag.flag.type = Flags::Null;
+	flag.setStatus(FlagGoing);
+	if (flag.isRandom()) {
+	  flag.setFlagType(Flags::Null);
 	}
 	sendFlagUpdate(flag);
       }
     }
   }
+  else if (strncasecmp(msg, "list", 4) == 0) {
+    FLAGMGR.sendFlagInfo(t);
+  }
   else if (strncasecmp(msg, "show", 4) == 0) {
-    for (int i = 0; i < numFlags; i++) {
+    for (int i = 0; i < FLAGMGR.size(); i++) {
       char showMessage[MessageLen];
-      FlagInfo::get(i)->getTextualInfo(showMessage);
+      FLAGMGR.getFlag(i)->getTextualInfo(showMessage);
       sendMessage(ServerPlayer, t, showMessage);
     }
   }
@@ -1342,10 +1350,10 @@
     }
     else if (strncasecmp(msg, "team", 4) == 0) {
       // team flags
-      for (int i = 0; i < numFlags; i++) {
-	FlagInfo* fi = FlagInfo::get(i);
-	if ((fi != NULL) && (fi->flag.type->flagTeam != NoTeam)) {
-	  const int playerIndex = fi->player;
+      for (int i = 0; i < FLAGMGR.size(); i++) {
+	FlagInfo* fi = FLAGMGR.getFlag(i);
+	if ((fi != NULL) && (fi->getTeamIndex() != NoTeam)) {
+	  const int playerIndex = fi->getPlayer();
 	  if (playerIndex != -1) {
 	    sendDrop(*fi);
 	  }
@@ -1358,9 +1366,9 @@
 	return true;
       }
       int fIndex = atoi(msg + 1);
-      FlagInfo* fi = FlagInfo::get(fIndex);
+      FlagInfo* fi = FLAGMGR.getFlag(fIndex);
       if (fi != NULL) {
-	const int playerIndex = fi->player;
+	const int playerIndex = fi->getPlayer();
 	if (playerIndex != -1) {
 	  sendDrop(*fi);
 	}
@@ -1372,10 +1380,10 @@
 	return true;
       }
       // by flag abbreviation
-      for (int i = 0; i < numFlags; i++) {
-	FlagInfo* fi = FlagInfo::get(i);
-	if ((fi != NULL) && (fi->flag.type == ft)) {
-	  const int playerIndex = fi->player;
+      for (int i = 0; i < FLAGMGR.size(); i++) {
+	FlagInfo* fi = FLAGMGR.getFlag(i);
+	if ((fi != NULL) && (fi->getFlagType() == ft)) {
+	  const int playerIndex = fi->getPlayer();
 	  if (playerIndex != -1) {
 	    sendDrop(*fi);
 	  }
@@ -1413,17 +1421,18 @@
       return true;
     }
 
-    FlagInfo* fi = FlagInfo::get(gkPlayer->player.getFlag());
+    FlagInfo* fi = FLAGMGR.getFlag(gkPlayer->player.getFlag());
     if (fi != NULL) {
-      sendDrop(*fi);
-      resetFlag(*fi);
+      // send the message before resetting the flag  (random flags)
       char buffer[MessageLen];
       snprintf(buffer, MessageLen, "%s took flag %s/%i from %s",
 	       playerData->player.getCallSign(),
-	       fi->flag.type->flagAbbv, fi->getIndex(),
+	       fi->getFlagType()->flagAbbv, fi->getIndex(),
 	       gkPlayer->player.getCallSign());
       sendMessage(ServerPlayer, t, buffer);
       sendMessage(ServerPlayer, AdminPlayers, buffer);
+      sendDrop(*fi);
+      resetFlag(*fi);
     } else {
       char buffer[MessageLen];
       snprintf(buffer, MessageLen,
@@ -1455,8 +1464,8 @@
 			  strncasecmp(argv[2].c_str(), "force", 5) == 0);
       if (argv[1][0] == '#') {
 	int fIndex = atoi(argv[1].c_str() + 1);
-	fi = FlagInfo::get(fIndex);
-	if ((fi != NULL) && ((fi->player >= 0) && !force)) {
+	fi = FLAGMGR.getFlag(fIndex);
+	if ((fi != NULL) && ((fi->getPlayer() >= 0) && !force)) {
 	  fi = NULL;
 	}
       }
@@ -1466,11 +1475,11 @@
 	  // find unused and forced candidates
 	  FlagInfo* unused = NULL;
 	  FlagInfo* forced = NULL;
-	  for (int i = 0; i < numFlags; i++) {
-	    FlagInfo* fi2 = FlagInfo::get(i);
-	    if ((fi2 != NULL) && (fi2->flag.type == ft)) {
+	  for (int i = 0; i < FLAGMGR.size(); i++) {
+	    FlagInfo* fi2 = FLAGMGR.getFlag(i);
+	    if ((fi2 != NULL) && (fi2->getFlagType() == ft)) {
 	      forced = fi2;
-	      if (fi2->player < 0) {
+	      if (fi2->getPlayer() < 0) {
 		unused = fi2;
 		break;
 	      }
@@ -1519,8 +1528,8 @@
       // deal with the player's current flag
       const int flagId = gkPlayer->player.getFlag();
       if (flagId >= 0) {
-	FlagInfo& currentFlag = *FlagInfo::get(flagId);
-	if (currentFlag.flag.type->flagTeam != NoTeam) {
+        FlagInfo& currentFlag = *FLAGMGR.getFlag(flagId);
+        if (currentFlag.getTeamIndex() != NoTeam) {
 	  // drop team flags
 	  dropFlag(currentFlag, gkPlayer->lastState.pos);
 	} else {
@@ -1530,11 +1539,12 @@
       }
 
       // deal with the flag's current player (for forced gives)
-      if (fi->player >= 0) {
-	GameKeeper::Player* fPlayer = GameKeeper::Player::getPlayerByIndex(fi->player);
+      if (fi->getPlayer() >= 0) {
+        GameKeeper::Player* fPlayer =
+          GameKeeper::Player::getPlayerByIndex(fi->getPlayer());
 	if (fPlayer) {
 	  void *bufStart = getDirectMessageBuffer();
-	  void *buf = nboPackUByte(bufStart, fi->player);
+          void *buf = nboPackUByte(bufStart, fi->getPlayer());
 	  buf = fi->pack(buf);
 	  broadcastMessage(MsgDropFlag, (char*)buf - (char*)bufStart, bufStart);
 	}
@@ -1555,12 +1565,72 @@
       char buffer[MessageLen];
       snprintf(buffer, MessageLen, "%s gave flag %s/%i to %s",
 	       playerData->player.getCallSign(),
-	       fi->flag.type->flagAbbv, fi->getIndex(),
+	       fi->getFlagType()->flagAbbv, fi->getIndex(),
 	       gkPlayer->player.getCallSign());
       sendMessage(ServerPlayer, t, buffer);
       sendMessage(ServerPlayer, AdminPlayers, buffer);
     }
   }
+  else if (strncasecmp(msg, "frtimes", 7) == 0) {
+    if (!checkFlagMaster(playerData)) {
+      return true;
+    }
+    msg += 7;
+    std::vector<std::string> argv = TextUtils::tokenize(msg, " \t", 0, true);
+    if (argv.size() < 2) {
+      flagCommandHelp(t);
+      return true;
+    }
+    const float min = atof(argv[0].c_str());
+    const float max = atof(argv[1].c_str());
+    FLAGMGR.setRandomDelayTimes(min, max);
+  }
+  else if (strncasecmp(msg, "frmax", 5) == 0) {
+    if (!checkFlagMaster(playerData)) {
+      return true;
+    }
+    msg += 5;
+    std::vector<std::string> argv = TextUtils::tokenize(msg, " \t", 0, true);
+    if (argv.size() < 1) {
+      flagCommandHelp(t);
+      return true;
+    }
+    FLAGMGR.userSetRandomCount(atoi(argv[0].c_str()), t);
+  }
+  else if (strncasecmp(msg, "fr", 2) == 0) {
+    if (!checkFlagMaster(playerData)) {
+      return true;
+    }
+    msg += 2;
+    while ((*msg != '\0') && isspace(*msg)) msg++; // eat whitespace
+    std::vector<std::string> argv = TextUtils::tokenize(msg, " \t", 0, true);
+    if (argv.size() < 1) {
+      flagCommandHelp(t);
+      return true;
+    }
+    int count = 1;
+    if (argv.size() > 1) {
+      count = atoi(argv[1].c_str());
+    }
+    FLAGMGR.userAdjustRandom(argv[0].c_str(), count, t);
+  }
+  else if (strncasecmp(msg, "ff", 2) == 0) {
+    if (!checkFlagMaster(playerData)) {
+      return true;
+    }
+    msg += 2;
+    while ((*msg != '\0') && isspace(*msg)) msg++; // eat whitespace
+    std::vector<std::string> argv = TextUtils::tokenize(msg, " \t", 0, true);
+    if (argv.size() < 1) {
+      flagCommandHelp(t);
+      return true;
+    }
+    int count = 1;
+    if (argv.size() > 1) {
+      count = atoi(argv[1].c_str());
+    }
+    FLAGMGR.userAdjustForced(argv[0].c_str(), count, t);
+  }
   else {
     flagCommandHelp(t);
   }
